<template>
  <div :class="classes">
    <slot />
  </div>
</template>

<script>

export default {
  name: 'Col',
  props: {
    span: {
      type: Number,
      default: null
    },
    sm: {
      type: Number,
      default: null
    },
    md: {
      type: Number,
      default: null
    },
    lg: {
      type: Number,
      default: null
    }
  },
  data () {
    return {
      classes: []
    };
  },
  beforeMount () {
    this.classes.push('col');
    this.span && this.classes.push(`col--${this.span}`);
    this.sm && this.classes.push(`col--sm-${this.sm}`);
    this.md && this.classes.push(`col--md-${this.md}`);
    this.lg && this.classes.push(`col--lg-${this.lg}`);
  }
};

</script>

<style scoped>

  .col {
    float: left;
    box-sizing: border-box;

    @for $i from 0 to 24 {
      &--$i {
        width: calc(1 / 24 * $(i) * 100)%;
      }

      @media (max-width: 479px) {
        &--sm-$i {
          width: calc(1 / 24 * $(i) * 100)%;
        }
      }

      @media (max-width: 1024px) {
        &--md-$i {
          width: calc(1 / 24 * $(i) * 100)%;
        }
      }

      @media (min-width: 1025px) {
        &--lg-$i {
          width: calc(1 / 24 * $(i) * 100)%;
        }
      }
    }
  }

</style>